<%
  # This truncation is only able to happen using legacy functionality of the Slack API
  # See https://api.slack.com/messaging/composing/layouts#when-to-use-attachments

  summary = "Total Quarantined Tests: *#{all.size}*\\n"

  types.each do |type, examples|
    summary += "Total #{type.to_s.titleize}: *#{examples.size}*\\n"
  end

  emojis = {
    bug: ':bug:',
    flaky: ':skull_and_crossbones:',
    new: ':new:',
    waiting_on: ':clock4:',
    investigating: ':mag:'
  }
%>
{
  "channel": "<%= ENV['SLACK_CHANNEL'] %>",
  "username": "<%= ENV['REPORT_NAME'] ||= 'QA E2E Quarantine Report' %>",
  "icon_emoji": ":biohazard_sign:",

  "blocks": [
    {
      "type": "section",
      "text": {
        "type": "mrkdwn",
        "text": "<%= summary %>"
      }
    }
  ],
  "attachments": [
    {
      "blocks": [
        { "type":  "divider" },

        <% types.each do |type, issues| %>
        {
          "type": "section",
          "text": {
            "type": "mrkdwn",
            "text": "<%= "#{emojis[type]} " if emojis.has_key?(type) %>*<%= type.to_s.titleize %>*"
          }
        },
        <% issues.each do |example| %>
        {
          "type": "section",
          "fields": [
            {
              "type": "mrkdwn",
              "text": "<%= example[:filename] %>"
            },
            {
              "type": "mrkdwn",
              <% if example[:issue_link] && example[:issue_id] %>
              "text": "<<%= example[:issue_link] %>|<%= example[:issue_id] %>>"
              <% else %>
              "text": "_no issue_"
              <% end %>
            }
          ]
        },
        <% end %>
        { "type": "divider" }<%= ',' unless type == types.keys.last %>
        <% end %>
      ]
    }
  ]
}
